
#include <stdio.h>
#include <stdlib.h>

#define MAX_LOCATIONS 4000
#define MAX_STACK     4000

int location[MAX_LOCATIONS];
int expression_stack[MAX_STACK];

int stackptr = 0;
int util0;

void runtime_error(char *msg)
{
  fprintf(stderr,"%s\n",msg);
  exit(1);
}

void multiply()
{
  if(stackptr > 1)
    expression_stack[stackptr - 2] = expression_stack[stackptr - 2]
      * expression_stack[stackptr - 1];
  else
    runtime_error("Stack underflow");

  stackptr--;
}

void divide()
{
  if(expression_stack[stackptr - 1] == 0)
    runtime_error("Division by zero");

  if(stackptr > 1)
    expression_stack[stackptr - 2] = expression_stack[stackptr - 2]
      / expression_stack[stackptr - 1];

  else
    runtime_error("Stack underflow");

  stackptr--;
}

void add()
{
  if(stackptr > 1)
    expression_stack[stackptr - 2] = expression_stack[stackptr - 2]
      + expression_stack[stackptr - 1];
  else
    runtime_error("Stack underflow");

  stackptr--;
}

void subtract()
{
  if(stackptr > 1)
    expression_stack[stackptr - 2] = expression_stack[stackptr - 2]
      - expression_stack[stackptr - 1];
  else
    runtime_error("Stack underflow");

  stackptr--;
}

int main()
{

